bcm53xx: detect Seama sysupgrade format
[openwrt/openwrt.git] / target / linux / bcm53xx / base-files / lib / upgrade / platform.sh
index 034fb8e6b8142d7d1d540b6a2cf1d7ff1f15dd73..e9a3dc49501862d0844be9b826cdcf7d30b99111 100644 (file)
@@ -26,6 +26,7 @@ platform_expected_image() {
        case "$machine" in
                "netgear,r6250v1")      echo "chk U12H245T00_NETGEAR"; return;;
                "netgear,r6300v2")      echo "chk U12H240T00_NETGEAR"; return;;
+               "netgear,r7000")        echo "chk U12H270T00_NETGEAR"; return;;
                "netgear,r8000")        echo "chk U12H315T00_NETGEAR"; return;;
        esac
 }
@@ -43,6 +44,10 @@ platform_identify() {
                        echo "chk"
                        return
                        ;;
+               "5ea3a417")
+                       echo "seama"
+                       return
+                       ;;
        esac
 
        magic=$(get_magic_long_at "$1" 14)
@@ -57,11 +62,6 @@ platform_identify() {
 platform_check_image() {
        [ "$#" -gt 1 ] && return 1
 
-       [ "$(platform_flash_type)" = "nand" ] && {
-               echo "Firmware upgrade on NAND devices is not implemented."
-               return 1
-       }
-
        local file_type=$(platform_identify "$1")
        local magic
        local error=0
@@ -99,6 +99,10 @@ platform_check_image() {
                                error=1
                        fi
                ;;
+               "seama")
+                       echo "Seama firmware format is unsupported"
+                       error=1
+               ;;
                "trx")
                        if ! otrx check "$1"; then
                                echo "Invalid (corrupted?) TRX firmware"
@@ -114,42 +118,38 @@ platform_check_image() {
        return $error
 }
 
-platform_extract_trx_from_chk() {
-       local header_len=$((0x$(get_magic_long_at "$1" 4)))
-
-       dd if="$1" of="$2" bs=$header_len skip=1
-}
-
-platform_extract_trx_from_cybertan() {
-       dd if="$1" of="$2" bs=32 skip=1
-}
-
 platform_pre_upgrade() {
        local file_type=$(platform_identify "$1")
        local dir="/tmp/sysupgrade-bcm53xx"
        local trx="$1"
+       local offset
 
        [ "$(platform_flash_type)" != "nand" ] && return
 
-       # Extract trx
+       # Find trx offset
        case "$file_type" in
-               "chk")          trx="/tmp/$1.trx"; platform_extract_trx_from_chk "$1" "$trx";;
-               "cybertan")     trx="/tmp/$1.trx"; platform_extract_trx_from_cybertan "$1" "$trx";;
+               "chk")          offset=$((0x$(get_magic_long_at "$1" 4)));;
+               "cybertan")     offset=32;;
        esac
 
        # Extract partitions from trx
        rm -fR $dir
        mkdir -p $dir
        otrx extract "$trx" \
+               ${offset:+-o $offset} \
                -1 $dir/kernel \
                -2 $dir/root
+       [ $? -ne 0 ] && {
+               echo "Failed to extract TRX partitions."
+               return
+       }
 
        # Firmwares without UBI image should be flashed "normally"
        local root_type=$(identify $dir/root)
-       [ "$root_type" != "ubi" ] && return
-
-       echo "Provided firmware contains kernel and UBI image, but flashing it is unsupported yet"
-       exit 1
+       [ "$root_type" != "ubi" ] && {
+               echo "Provided firmware doesn't use UBI for rootfs."
+               return
+       }
 
        # Prepare TRX file with just a kernel that will replace current one
        local linux_length=$(grep "\"linux\"" /proc/mtd | sed "s/mtd[0-9]*:[ \t]*\([^ \t]*\).*/\1/")
@@ -157,31 +157,62 @@ platform_pre_upgrade() {
                echo "Unable to find \"linux\" partition size"
                exit 1
        }
-       linux_length=$((0x$linux_length + 28))
+       linux_length=$((0x$linux_length))
+       local kernel_length=$(wc -c $dir/kernel | cut -d ' ' -f 1)
+       [ $kernel_length -gt $linux_length ] && {
+               echo "New kernel doesn't fit \"linux\" partition."
+               return
+       }
        rm -f /tmp/null.bin
        rm -f /tmp/kernel.trx
        touch /tmp/null.bin
        otrx create /tmp/kernel.trx \
-               -f $dir/kernel -b $linux_length \
+               -f $dir/kernel -b $(($linux_length + 28)) \
                -f /tmp/null.bin
+       [ $? -ne 0 ] && {
+               echo "Failed to create simple TRX with new kernel."
+               return
+       }
+
+       # Prepare UBI image (drop unwanted extra blocks)
+       local ubi_length=0
+       while [ "$(dd if=$dir/root skip=$ubi_length bs=1 count=4 2>/dev/null)" = "UBI#" ]; do
+               ubi_length=$(($ubi_length + 131072))
+       done
+       dd if=$dir/root of=/tmp/root.ubi bs=131072 count=$((ubi_length / 131072)) 2>/dev/null
+       [ $? -ne 0 ] && {
+               echo "Failed to prepare new UBI image."
+               return
+       }
 
        # Flash
        mtd write /tmp/kernel.trx firmware
+       nand_do_upgrade /tmp/root.ubi
+}
+
+platform_trx_from_chk_cmd() {
+       local header_len=$((0x$(get_magic_long_at "$1" 4)))
+
+       echo -n dd bs=$header_len skip=1
+}
+
+platform_trx_from_cybertan_cmd() {
+       echo -n dd bs=32 skip=1
 }
 
 platform_do_upgrade() {
        local file_type=$(platform_identify "$1")
        local trx="$1"
+       local cmd=
 
        [ "$(platform_flash_type)" == "nand" ] && {
-               echo "Flashing firmware without UBI for rootfs. All erase counters will be lost."
+               echo "Writing whole image to NAND flash. All erase counters will be lost."
        }
 
        case "$file_type" in
-               "chk")          trx="/tmp/$1.trx"; platform_extract_trx_from_chk "$1" "$trx";;
-               "cybertan")     trx="/tmp/$1.trx"; platform_extract_trx_from_cybertan "$1" "$trx";;
+               "chk")          cmd=$(platform_trx_from_chk_cmd "$trx");;
+               "cybertan")     cmd=$(platform_trx_from_cybertan_cmd "$trx");;
        esac
 
-       shift
-       default_do_upgrade "$trx" "$@"
+       default_do_upgrade "$trx" "$cmd"
 }